---
slug: /en/sql-reference/data-types/multiword-types
sidebar_position: 61
sidebar_label: Multiword Type Names
title: "Multiword Types"
---

When creating tables, you can use data types with a name consisting of several words. This is implemented for better SQL compatibility.

## Multiword Types Support

| Multiword types                  | Simple types                                                 |
|----------------------------------|--------------------------------------------------------------|
| DOUBLE PRECISION                 | [Float64](../../sql-reference/data-types/float.md)           |
| CHAR LARGE OBJECT                | [String](../../sql-reference/data-types/string.md)           |
| CHAR VARYING                     | [String](../../sql-reference/data-types/string.md)           |
| CHARACTER LARGE OBJECT           | [String](../../sql-reference/data-types/string.md)           |
| CHARACTER VARYING                | [String](../../sql-reference/data-types/string.md)           |
| NCHAR LARGE OBJECT               | [String](../../sql-reference/data-types/string.md)           |
| NCHAR VARYING                    | [String](../../sql-reference/data-types/string.md)           |
| NATIONAL CHARACTER LARGE OBJECT  | [String](../../sql-reference/data-types/string.md)           |
| NATIONAL CHARACTER VARYING       | [String](../../sql-reference/data-types/string.md)           |
| NATIONAL CHAR VARYING            | [String](../../sql-reference/data-types/string.md)           |
| NATIONAL CHARACTER               | [String](../../sql-reference/data-types/string.md)           |
| NATIONAL CHAR                    | [String](../../sql-reference/data-types/string.md)           |
| BINARY LARGE OBJECT              | [String](../../sql-reference/data-types/string.md)           |
| BINARY VARYING                   | [String](../../sql-reference/data-types/string.md)           |

[Original article](https://clickhouse.com/docs/en/sql-reference/data-types/multiword-types/) <!--hide-->
